#include "stdafx.h"

#include <exception>
#include <sstream>
#include "cameraexception.h"

namespace pco
{
  CameraException::CameraException()
  {
    msg_ = "pco::CameraException has been thrown without err_code.";
  }

  CameraException::CameraException(const int& code)
    : error_code_(code)
  {
    std::stringstream hex_code;
    hex_code << std::hex << code;
    char sz_error_txt[100];
    PCO_GetErrorTextSDK(static_cast<DWORD>(code), sz_error_txt, 100UL);
    error_text_ = std::string(sz_error_txt);
    msg_ = "pco::CameraException (0x" + hex_code.str() + "): " + error_text_;
  }

  CameraException::CameraException(const std::string msg, int code)
    : error_code_(code)
  {
    msg_ = "pco::CameraException: " + msg;
  }

  CameraException::~CameraException() noexcept
  {}

  const char* CameraException::what() const noexcept
  {
    return msg_.c_str();
  }

  const int CameraException::error_code() noexcept
  {
    return error_code_;
  }

  std::string CameraException::error_text() noexcept
  {
    return error_text_;
  }

}