#pragma once

namespace pco
{

  class CameraException : public std::exception
  {
  private:
    std::string msg_;
    const int error_code_ = PCO_ERROR_HIGHLEVELSDK;
    std::string error_text_ = "";
  public:
    explicit CameraException();
    explicit CameraException(const int& code);
    explicit CameraException(const std::string msg, int code = PCO_ERROR_HIGHLEVELSDK);
    virtual ~CameraException() noexcept;
    CameraException& operator=(CameraException) = delete;
    virtual const char* what() const noexcept override;
    const int error_code() noexcept;
    std::string error_text() noexcept;
  };

}